stages:
  - build
  - prep_qa
  - deploy_qa
  - deploy_prod

# Build image on dev VM
build_app_container:
  when: manual
  stage: build
  script:
    - docker build -t guillaumegoutaudier/cloud-native:app-build-$CI_COMMIT_SHORT_SHA ./app
    - docker login -u guillaumegoutaudier -p uve6ahN2aeG1pah0
    - docker push guillaumegoutaudier/cloud-native:app-build-$CI_COMMIT_SHORT_SHA
  artifacts:
    paths:
      - app/

# QA environment: AKS 
clean_up_qa:
  when: manual
  stage: prep_qa
  script: 
    - export KUBECONFIG=~/.kube/config-azure 
    - ./scripts/kill_k8s_app.sh
    - ./scripts/kill_k8s_db.sh
deploy_qa:
  when: manual
  stage: deploy_qa
  script: 
    - export KUBECONFIG=~/.kube/config-azure
    - kubectl create -f k8s/db.yml 
    - cat k8s/app_deployment_template.yml | sed -e "s/XXX/$CI_COMMIT_SHORT_SHA/" > k8s/app_deployment.yml
    - kubectl create -f k8s/app_deployment.yml 
    - kubectl create -f k8s/app_service.yml 
    - ./scripts/wait_for_app.sh
    - ./scripts/wait_for_db.sh
    - export APP_POD=`kubectl get all | grep pod/app-deployment | awk '{print $1}'`
    - echo $APP_POD
    - kubectl exec $APP_POD -- sh -c 'export MYSQL_MESSAGE="Hello from QA"; python3 /usr/src/app/init_db.py'
    - ./scripts/wait_for_app_lb.sh
    - export APP_IP=`kubectl get service/app-service | grep LoadBalancer | awk '{ print $4 }'`
    - python3 scripts/test_app.py
    - export APP_PATH="/db"
    - python3 scripts/test_app.py

# Prod environment: OKE
deploy_prod:
  when: manual
  stage: deploy_prod
  script:
    - export KUBECONFIG=~/.kube/config-oci
    - kubectl set image deployment app-deployment app-container=guillaumegoutaudier/cloud-native:app-build-$CI_COMMIT_SHORT_SHA  --record
    - kubectl rollout status deployment.v1.apps/app-deployment
    - export APP_IP=`kubectl get service/app-service | grep LoadBalancer | awk '{ print $4 }'`
    - python3 scripts/test_app.py
    - export APP_PATH="/db"
    - python3 scripts/test_app.py




